* Program....: SBTHERM2.PRG
* Version....: 1.0
* Author.....: Richard C Harlos II
* Date.......: January 11, 1996
* Notice.....: The contents of this file are placed in the Public Domain.
* Compiler...: FoxPro 2.6a for Windows
* Project....: F.I.R.E (Foxpro Innovations, Refinements and Enhancements)
* Abstract...: This is a demo program of a dual progress bar displayed in the
*               the Foxpro status bar.
* Comments...: It is based on the code contained in THERMO.PRG by Brian M.
*               Smith 100345,355 (his displayed a single progress indicator
*               in the status bar plus had a spinning star to show activity
*               between progress bar updates). The idea here  is to show
*               record-processing progress (in the right-hand bar) for each
*               file within a set of files, along with the file set-processing
*               progress (in the left hand bar).
* Parameters.: NONE.
* Assumptions: NONE.
* Sample Call: See demo code below.
* Notes......: The string to be displayed in the status bar cannot exceed 79
*               characters (apparently an internal Foxpro constraint) or a 
*               'syntax error' results (why not a 'string too long to fit'
*               error? Go figure ;-)
* Changes....:
***************************************************************************
*PARAMETERS
PRIVATE ALL LIKE l*
#DEFINE BEEP_SPKR ?? CHR( 7 )
*-* -    -    -    -    save current settings which this program will change.
lcOldSBar = SET( 'STATUS BAR' )
SET STATUS BAR ON
*-* -    -    -    -    alert user we're about to begin.
SET MESSAGE TO 'Press any key to begin demo...'
=INKEY( 0 )
*-* -    -    -   hypothetical test data: 7 files, 300 rec's each.
lnNumFiles = 7
lnNumRecs  = 300
*-* -    -    -    -    process the hypothetical files.
FOR lnFileNum = 1 TO lnNumFiles
	*-* -    -    -    - what percentage of the total files have we processed
	*-* -    -    -    - so far?
  	lnFilPrcnt = MAX( 1, INT( lnFileNum / lnNumFiles * 100 ) )
  	*-* -    -    -    - process the hypothetical records in the current
  	*-* -    -    -    - hypothetical file.
   FOR lnRecNum = 1 TO lnNumRecs
   	*-* -    -    -   what percentage of the total records have we processed
   	*-* -    -    -   so far?
   	lnRecPrcnt = MAX( 1, INT( lnRecNum  / lnNumRecs  * 100 ) )
   	*-* -    -    -   show the progress in the status bar (I passed by
   	*-* -    -    -   reference in the interest of performance).
      =SBT2( @lnFilPrcnt, @lnRecPrcnt )
   ENDFOR &&* lnRecNum = 1 TO lnNumRecs
ENDFOR &&* lnFileNum = 1 TO lnNumFiles
*-* -    -    -    -    signal user: the entire file-set has been processed.
BEEP_SPKR
SET MESSAGE TO 'Processing Complete!'
=INKEY( 3 )
*-* -    -    -    -    restore the settings changed for this demo (yes, this
*-* -    -    -    -    is user-friendly, developer-friendly and Foxpro
*-* -    -    -    -    environment-friendly software  (8^D)
SET MESSAGE TO
SET STATUS BAR &lcOldSBar
RETURN 
*-* ==================================== 
PROCEDURE SBT2
PARAMETERS tnPercent1, tnPercent2
PRIVATE ALL LIKE l*
*-*IF TYPE( 'tnPercent' ) = 'N'
	*-* -    -    -    - update the progress display.
   lnProgres1 = MAX( 1, INT( tnPercent1 / 4 ) )
   lnProgres2 = MAX( 1, INT( tnPercent2 / 4 ) )
   lcThisMsg = ;
   	'All: ' + ;
   	REPLICATE( CHR( 127 ), lnProgres1 ) + ;
   	REPLICATE( '-', 25 - lnProgres1 ) + ;
   	ALLTRIM( STR( INT( tnPercent1 ))) + '%' + ;
   	'   ||   This: ' + ;
   	REPLICATE( CHR( 127 ), lnProgres2 ) + ;
   	REPLICATE( '-', 25 - lnProgres2 ) + ;
   	ALLTRIM( STR( INT( tnPercent2 ))) + '%'
*-*ELSE
*-*	 -    -    -    - show the rotating 'activity' star.
*-*	lcThisMsg = SET( 'MESSAGE TO', 1 )
*-*	lcOldMsg  = LEFT( lcThisMsg, LEN( lcThisMsg ) - 1 )
*-*	lcStarChar = RIGHT( lcThisMsg, 1 )
*-*	DO CASE
*-*	   CASE lcStarChar = '+'
*-*	      lcThisMsg = lcOldMsg + CHR( 215 )
*-*	   CASE lcStarChar = CHR( 215 )
*-*	      lcThisMsg = lcOldMsg + '+'
*-*	   OTHERWISE
*-*			lcThisMsg = lcThisMsg + '+'
*-*	ENDCASE
*-*ENDIF && TYPE( 'tnPercent' ) = 'N'
SET MESSAGE TO lcThisMsg
RETURN .T.
*EOP SBarThrm
